// Messages
struct messages
{
    unsigned char pos;         // position
    unsigned char numchars;    // number of characters
    unsigned char msg[];       // message
};

// Declare the messages
const struct messages msg1 = {0x80, 16, "Jed's Tone Burst"};
const struct messages msg2 = {0xC4, 9, "Generator"};
const struct messages msg3 = {0xC2, 5, " 1 ms"};   // 2
const struct messages msg4 = {0xC2, 5, "10 ms"};   // 3
const struct messages msg5 = {0x82, 6, "Sweep "};  // 4
const struct messages msg6 = {0x82, 6, "10 Hz "};  // 5
const struct messages msg7 = {0x82, 6, "100 Hz"};  // 6
const struct messages msg8 = {0x80, 6, "oops! "};  // 7
const struct messages msg9 = {0x80, 2, "> "};      // 8
const struct messages msg10 = {0xC0, 2, "  "};     // 9
const struct messages msg11 = {0xC0, 2, "> "};     // 10
const struct messages msg12 = {0x80, 2, "  "};     // 11
const struct messages msg13 = {0x82, 5, "1 Hz  "}; // 5

void domsg(const struct messages *);
//--------------------------------------------------------
// For reading, debouncing, and processing the switches
struct myswitch
{
    unsigned char debounce;     // debounce byte
    unsigned char state;        // debounced state of the switch
    unsigned char old;          // old state
    unsigned char press;        // switch has been pressed
    unsigned char count;        // how long the press counter has been running
    unsigned char release;      // how long the release counter has been running
    unsigned char countrun;     // is the counter running?
};

// Declare and initialize the switches
struct myswitch switch1 = {0xFF, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00};
struct myswitch switch2 = {0xFF, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00};
struct myswitch switch3 = {0xFF, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00};
struct myswitch switch4 = {0xFF, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00};

// Reading the switches: PortIn, Bit, switch structure
void do_switch(unsigned char, unsigned char, struct myswitch *);

void sw_burst_delay(void);  // read the switches for burst mode
void sw_burst_freq(void);   // read the switches for frequency mode
void burst_delay(void);
void burst_freq(void);
void do_frequency(unsigned int);      // Send the frequency to the AD9833 and display it
void do_frequency_only(unsigned int); // Send the frequency to the AD9833 but don't display it
void sweep_freq(void);

void waitsec(void);    // Delay for Greeting message
//--------------------------------------------------------
// Globals
volatile unsigned int timer_flag = 10, timer_count = 10;
volatile long temp,temp1,temp2;
volatile unsigned int time_off = 50;
int time_step = 1;      // 1 ms

unsigned char mode, burst_mode, state, count, switch_time;

unsigned long dds_data;
static int frequency = 400;
int freq_step = 100;
unsigned char sweep;
unsigned static long lfreq;
//--------------------------------------------------------
// For AD9833   DDS: Fout = Data * 25MHz/2^32
void do_dds(unsigned int);
void do_dds_data(unsigned long);

// For LCD
void display_frequency(unsigned long);

void lcd_init(void);
void lcd_reset(void);
void wait10ms(void);
void lcd_wr4(unsigned int);
void lcd_wr_instr(unsigned int);
void lcd_wr_data(unsigned int);
void lcd_wr_bcd(unsigned int, unsigned int);  // position, value
void lcd_wr_bcd_long(unsigned int, unsigned long);
void clear_lcd(unsigned char);
//=============================================================
